"""A https server built on Medusa's http_server. 

This server has been stable for my Zope needs. YMMV.
Usual disclaimers apply.

Copyright (c) 1999-2000 Ng Pheng Siong. All rights reserved."""

RCS_id='$Id: https_server.py,v 1.1 2000/02/01 15:20:59 ngps Exp ngps $'

import asyncore
import asynchat
import http_server
import socket
import sys

from M2Crypto import SSL

VERSION_STRING='0.04'

class https_channel(http_server.http_channel):

    def __init__(self, server, conn, addr):
        http_server.http_channel.__init__(self, server, conn, addr)

    def send(self, data):
        result=self.socket._write_nbio(data)
        if result == -1:
            return 0
        elif result == 0:
            #self.socket.set_shutdown(SSL.SSL_SENT_SHUTDOWN)
            return 0
        else:
            self.server.bytes_out.increment(result)
            return result

    def recv(self, buffer_size):
        result=self.socket._read_nbio(buffer_size)
        if result is None:
            return ''
        elif result is '':
            self.socket.set_shutdown(SSL.SSL_RECEIVED_SHUTDOWN)
            return ''
        else:
            self.server.bytes_in.increment(len(result))
            return result


class https_server(http_server.http_server):

    SERVER_IDENT='M2Crypto HTTPS Server (v%s)' % VERSION_STRING

    channel_class=https_channel

    def __init__(self, ip, port, ssl_ctx, resolver=None, logger_object=None):
        http_server.http_server.__init__(self, ip, port, resolver, logger_object)
        self.ssl_ctx=ssl_ctx
        sys.stdout.write(self.SERVER_IDENT+'\n')
        sys.stdout.flush()
        
    def handle_accept(self):
        # Cribbed from http_server.
        self.total_clients.increment()
        try:
            conn, addr = self.accept()
        except socket.error:
            # linux: on rare occasions we get a bogus socket back from
            # accept.  socketmodule.c:makesockaddr complains that the
            # address family is unknown.  We don't want the whole server
            # to shut down because of this.
            sys.log_info ('warning: server accept() threw an exception', 'warning')
            return
        except TypeError:
                # unpack non-sequence.  this can happen when a read event
                # fires on a listening socket, but when we call accept()
                # we get EWOULDBLOCK, so dispatcher.accept() returns None.
                # Seen on FreeBSD3.
                self.log_info ('warning: server accept() threw EWOULDBLOCK', 'warning')
                return
        
        # Turn the vanilla socket into an SSL connection.
        ssl_conn=SSL.Connection(self.ssl_ctx, conn)
        ssl_conn._setup_ssl(addr)
        try:
            ssl_conn.accept_ssl()
        except:
            ssl_conn.close()
        self.channel_class(self, ssl_conn, addr)

    def writeable(self):
        return 0

